<?php


/*
   ----------------------------------------------------------------------
   GLPI - Gestionnaire Libre de Parc Informatique
   Copyright (C) 2003-2008 by the INDEPNET Development Team.

   http://indepnet.net/   http://glpi-project.org/
   ----------------------------------------------------------------------

   LICENSE

   This file is part of GLPI.

   GLPI is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GLPI is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GLPI; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   ------------------------------------------------------------------------
 */

// Original Author of file: Walid Nouh (walid.nouh@atosorigin.com)
// Purpose of file:
// ----------------------------------------------------------------------
if (!defined('GLPI_ROOT')) {
	define('GLPI_ROOT', '../../..');
}

$NEEDED_ITEMS=array("ocsng", "mass_ocs_import");
include (GLPI_ROOT."/inc/includes.php");

checkRight("ocsng", "w");

function configHeader () {
	global $OCSMASSIMPORTLANG;
	
	echo "<div align='center'>";
	echo "<table class='tab_cadre' cellpadding='5'>";
	echo "<tr><th>".$OCSMASSIMPORTLANG["config"][1]."</th></tr>";
	echo "<tr class='tab_bg_1'><td align='center'><a href='http://glpi-project.org/wiki/doku.php?id=".substr($_SESSION["glpilanguage"],0,2).":plugins:mass_ocs_import_use' target='_blank'>".$OCSMASSIMPORTLANG["setup"][8]."</a></td></tr>";
}

if (isset($_POST["update_config"]))
{
	$config = new MassOCSImportConfig;
	$config->update($_POST);
	glpi_header($_SERVER['PHP_SELF']);
}
if (isset($_POST["soft_lock"]))
{
	setScriptLock();
}
if (isset($_POST["soft_unlock"]))
{
	removeScriptLock();
}

commonHeader($OCSMASSIMPORTLANG["config"][1], $_SERVER["PHP_SELF"],"config","plugins");

if (!$CFG_GLPI["ocs_mode"]) {

	configHeader();

	echo "<tr class='tab_bg_2'><td align='center'>".$OCSMASSIMPORTLANG["setup"][0].
		" : <a href='../../../front/setup.config.php?onglet=3'>".$OCSMASSIMPORTLANG["setup"][2]."</a></th></tr>";

	echo "</table></div>";

} else if (!countElementsInTable("glpi_ocs_config")) {
	
	configHeader();

	echo "<tr class='tab_bg_2'><td align='center'>".$OCSMASSIMPORTLANG["setup"][1].
		" : <a href='../../../front/setup.ocsng.php'>".$OCSMASSIMPORTLANG["setup"][2]."</a></th></tr>";

	echo "</table></div>";

} else if (!isset($_SESSION["glpi_plugin_mass_ocs_import_installed"]) || $_SESSION["glpi_plugin_mass_ocs_import_installed"]!=1) {
	
	configHeader();
	
	if (haveRight("config","w")) {
		if (TableExists("glpi_plugin_mass_ocs_import_servers") ||
			TableExists("glpi_plugin_mass_ocs_import") ||
			TableExists("glpi_plugin_mass_ocs_import_config") ||
			TableExists("glpi_plugin_mass_ocs_import_not_imported")) {
				$info=plugin_version_mass_ocs_import();
				echo "<tr class='tab_bg_1'><td align='center'>";
				echo "<a href='plugin_mass_ocs_import.install.php'>".$OCSMASSIMPORTLANG["setup"][4]."&nbsp;". $info['version']."</a></td></tr>";
	
				echo "<tr class='tab_bg_1'><td align='center'>";
				echo "<a href='plugin_mass_ocs_import.uninstall.php'>".$OCSMASSIMPORTLANG["setup"][5]."</a></td></tr>";
		} else {
				echo "<tr class='tab_bg_1'><td align='center'>";
				echo "<a href='plugin_mass_ocs_import.install.php'>".$OCSMASSIMPORTLANG["setup"][3]."</a></td></tr>";		
		}		
	}
	echo "</table></div>";

} else { // 

	$config = new MassOCSImportConfig;
	$config->showAdminForm($_SERVER['PHP_SELF']);
}

commonFooter();
?>
