<?php
/*
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2008 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

	This file is part of GLPI.

    GLPI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GLPI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GLPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
*/

// Original Author of file: Walid Nouh
// Purpose of file:
// ----------------------------------------------------------------------

include_once ("plugin_mass_ocs_import.includes.php");

function plugin_init_mass_ocs_import() {
	global $PLUGIN_HOOKS,$CFG_GLPI,$OCSMASSIMPORTLANG;

	$PLUGIN_HOOKS['init_session']['mass_ocs_import'] = 'plugin_mass_ocs_import_initSession';
	$PLUGIN_HOOKS['change_profile']['mass_ocs_import'] = 'plugin_mass_ocs_import_changeprofile';
	
	if(isset($_SESSION["glpi_plugin_mass_ocs_import_installed"]) && $_SESSION["glpi_plugin_mass_ocs_import_installed"] == 1)
	{
		if (haveRight("logs","r") || haveRight("ocsng","w")) {
			$PLUGIN_HOOKS['menu_entry']['mass_ocs_import'] = true;
			$PLUGIN_HOOKS['submenu_entry']['mass_ocs_import']['config'] = 'front/plugin_mass_ocs_import.config.form.php'; 
			$PLUGIN_HOOKS['central_action']['mass_ocs_import'] = 'plugin_central_action_mass_ocs_import';
		}

		if (haveRight("ocsng","w")) {
			// Config page
			$PLUGIN_HOOKS['config_page']['mass_ocs_import'] = 'front/plugin_mass_ocs_import.config.form.php';
		}
		//Launch cron every hour
		$PLUGIN_HOOKS['cron']['mass_ocs_import'] = HOUR_TIMESTAMP;
	}
	else if (haveRight("config","w")) {
		// Config page
		$PLUGIN_HOOKS['config_page']['mass_ocs_import'] = 'front/plugin_mass_ocs_import.config.form.php';
	}
		
}

	
function plugin_version_mass_ocs_import() {
	global $OCSMASSIMPORTLANG;

		return array ('name' => $OCSMASSIMPORTLANG["name"][1], 'version' => '1.2');
	}

function cron_plugin_mass_ocs_import()
{
	if(isset($_SESSION["glpi_plugin_mass_ocs_import_installed"]) && $_SESSION["glpi_plugin_mass_ocs_import_installed"] == 1)
	{
		$nb=cronDeleteThreads();
		if ($nb>0) 
			logInFile("cron","Clean mass_ocs_import : $nb reports deleted\n");
		else	logInFile("cron","Clean mass_ocs_import : nothing to do\n");
	}
}

function plugin_central_action_mass_ocs_import()
{
	getNotImportedMachinesNumer();
}
?>
